import { useEffect, useState } from "react";

export function useDebounce<T>(value: T, delay: number): T { /* T => indica o tipo de valor e garante que o valor que é passado é igual ao tipo que entra no hook*/
    const [debouncedValue, setDebouncedValue] = useState<T>(value);

    useEffect(() => {
        const timer = setTimeout(() => {
            setDebouncedValue(value);
        }, delay);

        return () => clearTimeout(timer); // limpa se o valor mudar antes do delay
    }, [value, delay]);

    return debouncedValue;
}